import {
  world,
  system,
  ItemStack
} from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('ip:bed_pet', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;

      const durability = item.getComponent('minecraft:durability');
      if (durability.maxDurability < durability.damage + 1) {
       player.sendMessage("§7No energy!")
       return;
     }
      item.getComponent('cooldown').startCooldown(player);
     if(player.dimension.id !== 'minecraft:overworld') {
       player.sendMessage("§7The bed pet doesn't want you to do this..")
       return;
     }

     const time = world.getTimeOfDay();
     if(time < 12542 || time > 23459) {
       player.sendMessage('§7You can only sleep at night')
       return;
     }

    const inv = player.getComponent('minecraft:inventory').container;
     durability.damage += durability.maxDurability - durability.damage;
     inv.setItem(player.selectedSlotIndex, item);
     
     world.sendMessage('Sleeping through this night');
     system.runTimeout(() => {
       world.setTimeOfDay(0);
     }, 50);

    }
  });

});
