import {
  world,
  system,
  ItemStack
} from "@minecraft/server";
world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('ip:creaking_pet', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;
      const durability = item.getComponent('minecraft:durability');
      if (durability.maxDurability < durability.damage + 1) {
        player.sendMessage("§7No energy!")
        return;
      }
      item.getComponent('cooldown').startCooldown(player);

      player.addEffect('resistance', 60, {amplifier:5});
      player.addEffect('slowness', 60, {amplifier:5});
      player.addEffect('regeneration', 60, {amplifier:1});
      player.playSound('entity.creaking.step')

      const inv = player.getComponent('minecraft:inventory').container;
      durability.damage += durability.maxDurability - durability.damage;
      inv.setItem(player.selectedSlotIndex, item);

    }
  });
});