import {
  world,
  system,
  ItemStack
} from "@minecraft/server";
world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('ip:creeper_pet', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;
      const durability = item.getComponent('minecraft:durability');
      if (durability.maxDurability < durability.damage + 1) {
        player.sendMessage("§7No energy!")
        return;
      }
      item.getComponent('cooldown').startCooldown(player);

      player.addEffect('resistance', 1, {amplifier:5});
      player.dimension.createExplosion(player.location, 4, {source: player});


      const inv = player.getComponent('minecraft:inventory').container;
      durability.damage += durability.maxDurability - durability.damage;
      inv.setItem(player.selectedSlotIndex, item);

    }
  });
});