import {
  world,
  system,
  ItemStack
} from "@minecraft/server";
world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.itemComponentRegistry.registerCustomComponent('ip:enderman_pet', {
    onUse(e) {
      const player = e.source;
      const item = e.itemStack;
      const durability = item.getComponent('minecraft:durability');
      if (durability.maxDurability < durability.damage + 1) {
        player.sendMessage("§7No energy!")
        return;
      }
      item.getComponent('cooldown').startCooldown(player);
      const teleportCast = player.getBlockFromViewDirection({
        maxDistance: 77,
        includePassableBlocks: false,
        includeLiquidBlocks: true
      });
      if (!teleportCast) {
        player.sendMessage("§7No blocks in range")
        return;
      }
      const block = teleportCast.block.location;
      const faceLocation = teleportCast.faceLocation;
      var x = 0;
      var y = 0;
      var z = 0;
      const teleportCheck = player.tryTeleport({
        x: block.x + faceLocation.x,
        y: block.y + faceLocation.y,
        z: block.z + faceLocation.z
      }, {
        checkForBlocks: false
      });
      if (teleportCheck === true) {
        const inv = player.getComponent('minecraft:inventory').container;
        durability.damage += durability.maxDurability - durability.damage;
        inv.setItem(player.selectedSlotIndex, item);
        system.runTimeout(() => {
          player.playSound('mob.shulker.teleport')
        }, 1);
      } else {
        player.sendMessage("§7Teleport failed")
      }
    }
  });
});