import {
  world,
  system,
  ItemStack
} from '@minecraft/server';
const foodData = [{
    pet: "ip:chicken_pet",
    food: "minecraft:wheat_seeds"
  },
  {
    pet: "ip:slime_pet",
    food: "minecraft:slime_ball"
  },
  {
    pet: "ip:blaze_pet",
    food: "minecraft:blaze_powder"
  },
  {
    pet: "ip:enderman_pet",
    food: "ip:obsidian_chunk"
  },
  {
    pet: "ip:bed_pet",
    food: "minecraft:feather"
  },
  {
    pet: "ip:creeper_pet",
    food: "minecraft:gunpowder"
  },
  {
    pet: "ip:breeze_pet",
    food: "minecraft:breeze_rod"
  },
  {
    pet: "ip:axolotl_pet",
    food: "ip:diamond_shard"
  },
  {
    pet: "ip:spider_pet",
    food: "minecraft:beef"
  },
  {
    pet: "ip:squid_pet",
    food: "minecraft:cod"
  },
  {
    pet: "ip:glow_squid_pet",
    food: "minecraft:glowstone_dust"
  },
  {
    pet: "ip:creaking_pet",
    food: "minecraft:resin_block"
  }
];
system.runInterval(() => {
  for (const player of world.getPlayers()) {
    player.removeTag('ip:spider_pet');
    player.getComponent('minecraft:underwater_movement').setCurrentValue(player.getComponent('minecraft:underwater_movement').defaultValue);
    const inv = player.getComponent('minecraft:inventory').container;
    for (let i = 0; i < 9; i++) {
      const item = inv.getItem(i);
      if (!item) continue;
      if (item.hasTag('ip:pet') && item.hasTag('ip:decrease_overtime')) {
        const durability = item.getComponent('minecraft:durability');
        if (durability.maxDurability < durability.damage + 1) {
          for (let j = 0; j < 36; j++) {
            const food = inv.getItem(j);
            if (!food) continue;
            const foundFood = foodData.find(foodCheck => foodCheck.pet === item.typeId);
            if (!foundFood) continue;
            if (food.typeId === foundFood.food) {
              durability.damage -= durability.damage;
              inv.setItem(i, item);
              if (food.amount > 1) {
                food.amount -= 1;
                inv.setItem(j, food);
              } else {
                inv.setItem(j, undefined);
              }
              player.playSound('random.eat');
              break;
            }
          }
        } else {
          if (item.typeId === 'ip:spider_pet') {
            player.addTag('ip:spider_pet');
          } else if (item.typeId === 'ip:squid_pet') {
            if (player.isSwimming) {
              let waterSpeed = player.getComponent('minecraft:underwater_movement');
              if(waterSpeed.currentValue < 0.05) {
                waterSpeed.setCurrentValue(0.05);
              }
            }
          } else if (item.typeId === 'ip:glow_squid_pet') {
            player.addEffect('night_vision', 221, {
              amplifier: 0,
              showParticles: false
            });
          } else if (item.typeId === 'ip:chicken_pet') {
            player.addEffect('slow_falling', 40, {
              amplifier: 0,
              showParticles: false
            });
            player.addEffect('speed', 40, {
              amplifier: 0,
              showParticles: false
            });
          } else if (item.typeId === 'ip:slime_pet') {
            player.addEffect('jump_boost', 40, {
              amplifier: 5,
              showParticles: false
            });
          } else if (item.typeId === 'ip:blaze_pet') {
            player.addEffect('fire_resistance', 40, {
              amplifier: 0,
              showParticles: false
            });
            player.addEffect('strength', 40, {
              amplifier: 0,
              showParticles: false
            });
          } else if (item.typeId === 'ip:breeze_pet') {
            if(player.isSneaking && !player.isOnGround) {
            player.addEffect('levitation', 25, {
              amplifier: 2,
              showParticles: true
            });
            } else { continue; }
          } else if (item.typeId === 'ip:axolotl_pet') {
            let hp = player.getComponent('minecraft:health')
            if (hp.currentValue === hp.defaultValue) continue;
            hp.setCurrentValue(hp.currentValue + 1)
     system.runTimeout(() => {hp.setCurrentValue(hp.currentValue + 1)}, 7);
     system.runTimeout(() => {hp.setCurrentValue(hp.currentValue + 1)}, 14);
          }
          durability.damage++;
          inv.setItem(i, item);
        }
      } else if (item.hasTag('ip:pet') && !item.hasTag('ip:decrease_overtime')) {
        const durability = item.getComponent('minecraft:durability');
        if (durability.maxDurability < durability.damage + 1) {
          for (let j = 0; j < 27; j++) {
            const food = inv.getItem(j);
            if (!food) continue;
            const foundFood = foodData.find(foodCheck => foodCheck.pet === item.typeId);
            if (!foundFood) continue;
            if (food.typeId === foundFood.food) {
              durability.damage -= durability.damage;
              inv.setItem(i, item);
              if (food.amount > 1) {
                food.amount -= 1;
                inv.setItem(j, food);
              } else {
                inv.setItem(j, undefined);
              }
              player.playSound('random.eat');
              break;
            }
          }
        }
      }
    }
  }
}, 20);