import {
  world,
  system,
  ItemStack
} from "@minecraft/server";
const validEntities = [
  'minecraft:chicken',
  'minecraft:slime',
  'minecraft:blaze',
  'minecraft:creeper',
  'minecraft:enderman',
  'minecraft:breeze',
  'minecraft:axolotl',
  'minecraft:spider',
  'minecraft:creaking',
  'minecraft:squid',
  'minecraft:glow_squid'
];
world.afterEvents.entityDie.subscribe((event) => {
  const deadEntity = event.deadEntity;
  const damageSource = event.damageSource.damagingEntity;
  if (!damageSource) return;
  if (damageSource.typeId !== 'minecraft:player') return;
  if (!validEntities.includes(deadEntity.typeId)) return;

  if (deadEntity.typeId === 'minecraft:chicken') {
    const randomChance = Math.floor(Math.random() * 100);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:chicken_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:slime') {
    const randomChance = Math.floor(Math.random() * 66);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:slime_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:blaze') {
    const randomChance = Math.floor(Math.random() * 75);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:blaze_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:creaking') {
    const randomChance = Math.floor(Math.random() * 10);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:creaking_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:squid') {
    const randomChance = Math.floor(Math.random() * 75);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:squid_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:glow_squid') {
    const randomChance = Math.floor(Math.random() * 80);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:glow_squid_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:creeper') {
    const randomChance = Math.floor(Math.random() * 100);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:creeper_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:spider') {
    const randomChance = Math.floor(Math.random() * 111);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:spider_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:enderman') {
    const randomChance = Math.floor(Math.random() * 66);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:enderman_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:breeze') {
    const randomChance = Math.floor(Math.random() * 25);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:breeze_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  } else if (deadEntity.typeId === 'minecraft:axolotl') {
    const randomChance = Math.floor(Math.random() * 30);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:axolotl_pet', 1);
      system.runTimeout(() => {
        damageSource.dimension.spawnItem(pet, deadEntity.location);
        deadEntity.dimension.spawnParticle('ip:pet_spawn', deadEntity.location)
        deadEntity.dimension.playSound('block.end_portal_frame.fill', deadEntity.location);
      }, 10);
    }
  }
});