import {
  world,
  system,
  ItemStack
} from "@minecraft/server";

world.afterEvents.dataDrivenEntityTrigger.subscribe((event) => {
  const mob = event.entity;
  const eventId = event.eventId;
  if (eventId !== 'minecraft:start_twitching') {
    return;
  }

  if (mob.typeId === 'minecraft:creaking') {
    const randomChance = Math.floor(Math.random() * 10);
    if (randomChance === 0) {
      const pet = new ItemStack('ip:creaking_pet', 1);
      system.runTimeout(() => {
        mob.dimension.spawnItem(pet, mob.location);
        mob.dimension.spawnParticle('ip:pet_spawn', mob.location)
        mob.dimension.playSound('block.end_portal_frame.fill', mob.location);
      }, 44);
    }
  }
});
