import {
  world,
  system,
  ItemStack
} from '@minecraft/server';

system.runInterval(() => {
  for (const player of world.getPlayers({tags: ['ip:spider_pet']})) {
    if(!player.isJumping) return;
    const x = player.location.x;
    const y = player.location.y;
    const z = player.location.z;
    const dim = player.dimension

    let blocks = [
      dim.getBlock({x: x+0.4, y: y+0.4, z: z}),
      dim.getBlock({x: x-0.4, y: y+0.4, z: z}),
      dim.getBlock({x: x, y: y+0.4, z: z+0.4}),
      dim.getBlock({x: x, y: y+0.4, z: z-0.4}),
      dim.getBlock({x: x+0.4, y: y+0.4, z: z+0.4}),
      dim.getBlock({x: x-0.4, y: y+0.4, z: z+0.4}),
      dim.getBlock({x: x+0.4, y: y+0.4, z: z-0.4}),
      dim.getBlock({x: x-0.4, y: y+0.4, z: z-0.4}),
      dim.getBlock({x: x+0.4, y: y+0.9, z: z}),
      dim.getBlock({x: x-0.4, y: y+0.9, z: z}),
      dim.getBlock({x: x, y: y+0.9, z: z+0.4}),
      dim.getBlock({x: x, y: y+0.9, z: z-0.4}),
      dim.getBlock({x: x+0.4, y: y+0.9, z: z+0.4}),
      dim.getBlock({x: x-0.4, y: y+0.9, z: z+0.4}),
      dim.getBlock({x: x+0.4, y: y+0.9, z: z-0.4}),
      dim.getBlock({x: x-0.4, y: y+0.9, z: z-0.4})
    ]

    const invalid = [
      'minecraft:cave_vines',
      'minecraft:cave_vines_body_with_berries',
      'minecraft:cave_vines_head_with_berries',
      'minecraft:tube_coral',
      'minecraft:tube_coral_fan',
      'minecraft:brain_coral',
      'minecraft:brain_coral_fan',
      'minecraft:bubble_coral',
      'minecraft:bubble_coral_fan',
      'minecraft:fire_coral',
      'minecraft:fire_coral_fan',
      'minecraft:horn_coral',
      'minecraft:horn_coral_fan',
      'minecraft:dead_tube_coral',
      'minecraft:dead_tube_coral_fan',
      'minecraft:dead_brain_coral',
      'minecraft:dead_brain_coral_fan',
      'minecraft:dead_bubble_coral',
      'minecraft:dead_bubble_coral_fan',
      'minecraft:dead_fire_coral',
      'minecraft:dead_fire_coral_fan',
      'minecraft:dead_horn_coral',
      'minecraft:dead_horn_coral_fan',
      'minecraft:wheat',
      'minecraft:carrots',
      'minecraft:potatoes',
      'minecraft:melon_stem',
      'minecraft:pumpkin_stem',
      'minecraft:torchflower_crop',
      'minecraft:pitcher_crop',
      'minecraft:bamboo',
      'minecraft:bamboo_sapling',
      'minecraft:cocoa',
      'minecraft:reeds',
      'minecraft:sweet_berry_bush',
      'minecraft:kelp',
      'minecraft:nether_wart',
      'minecraft:light_block_0',
      'minecraft:light_block_1',
      'minecraft:light_block_2',
      'minecraft:light_block_3',
      'minecraft:light_block_4',
      'minecraft:light_block_5',
      'minecraft:light_block_6',
      'minecraft:light_block_7',
      'minecraft:light_block_8',
      'minecraft:light_block_9',
      'minecraft:light_block_10',
      'minecraft:light_block_11',
      'minecraft:light_block_12',
      'minecraft:light_block_13',
      'minecraft:light_block_14',
      'minecraft:light_block_15',
      'minecraft:pink_petals',
      'minecraft:pitcher_plant',
      'minecraft:torchflower',
      'minecraft:powder_snow',
      'minecraft:redstone_torch',
      'minecraft:torch',
      'minecraft:soul_torch',
      'minecraft:snow_layer',
      'minecraft:vines',
      'minecraft:twisting_vines',
      'minecraft:creeping_vines',
      'minecraft:short_grass',
      'minecraft:tall_grass',
      'minecraft:red_flower',
      'minecraft:yellow_flower',
      'minecraft:open_eyeblossom',
      'minecraft:closed_eyeblossom',
      'minecraft:fern',
      'minecraft:double_plant'
    ]

    for (const block of blocks) {
      if(block.isAir || block.isLiquid || invalid.includes(block.typeId)) continue;
      player.addEffect('levitation', 5, {amplifier: 2, showParticles: false});
      player.addEffect('slow_falling', 8, {amplifier: 0, showParticles: false});
      return;
    }

  }
});